<template>
  <q-form ref="formRef" @submit="handleAddPerson" @reset="handleResetForm">
    <q-input :label="$t('required.name')" :rules="[(val) => (val && val.length > 0) || $t('empty.name')]" filled
      v-model="Name" />
    <div class="row q-col-gutter-sm">
      <q-select class="col-12  col-md-6" filled :options="phoneNums" v-model="phoneCode" />
      <q-input class="col-12 col-md-6" :label="$t('required.phone_number')" filled v-model="number" type="number" :rules="[
        (val) => (val && val.length > 0) || $t('empty.phone_number'),
        (val) => validPhoneNumberRule(val) || $t('invalid.phone_number'),
        duplicatePhoneNumberRule,
        // Here we make sure the user doesn't try to add themself
        (val) =>
          phoneCode.value.code +
          val
            .substring(1)
            .split(' ')
            .join('') !==
          usersPhone || $t('invite_arbitrary_number.your_phone_number'),
      ]" />
    </div>
    <div class="row items-center justify-between">
      <div style="align-items: left; margin-bottom: 10px" class="column">
        <q-checkbox v-if="offerAddContact" v-model="AddContact" :label="$t('invite_arbitrary_number.save_to_contacts')" />
        <div v-if="!hideModerator" style="align-items: center" class="row">
          <q-checkbox v-model="Moderator" :label="$t('moderator')" />
          <q-icon color="orange" name="star" style="margin-right:5px; margin-left:5px; font-size: 1em;" />

          <q-icon name="help" class="q-ml-sm cursor-pointer" color="grey-9">
            <q-tooltip>
              <div class="text-body2">
                {{ $t("moderator_explanation") }}
              </div>
            </q-tooltip>
          </q-icon>
        </div>
      </div>


      <q-space />
      <q-btn type="submit" color="primary" rounded :icon-right="type === 'save' ? 'save' : 'add'">
        {{
          $t(
            `invite_arbitrary_number.${this.type === "save" ? "save_person" : "add_person"
            }`
          )
        }}&nbsp;
      </q-btn>
    </div>
  </q-form>
</template>
<script>
import { phoneCodes, validPhoneNumber, parseNumber } from "../utils/phone";

export default {
  props: {
    participants: {
      required: true,
      // { phoneNumber: { Name: string, Moderator: bool } }
    },
    offerAddContact: {
      type: Boolean,
      default: false
    },
    inviteParticipant: {
      required: true,
      // (phoneNumber: string, participant: { Name: string, Moderator: bool } }) => void
    },
    usersPhone: {
      required: true,
      type: String,
    },
    hideModerator: {
      type: Boolean,
      required: false,
    },
    defaultName: {
      type: String,
      required: false,
    },
    defaultNumber: {
      type: String,
      required: false,
    },
    defaultPhoneCode: {
      type: String,
      required: false,
    },
    type: {
      type: String,
      required: false,
      // "add" | "save"
    },
  },
  data()
  {
    return {
      number: this.defaultNumber || "",
      Name: this.defaultName || "",
      Moderator: false,
      AddContact: false,
      phoneCode: {
        label: "",
        value: ""
      }
    };
  },
  mounted()
  {
    this.phoneCode = {
      label: this.defaultPhoneCode || `${this.orderedPhoneCodes[0].code} (${this.orderedPhoneCodes[0].country})`,
      value: this.defaultPhoneCode ? { code: this.defaultPhoneCode } : this.orderedPhoneCodes[0]
    }
  },
  computed: {
    orderedPhoneCodes()
    {
      return phoneCodes();
    },
    phoneNums()
    {
      return this.orderedPhoneCodes.map((phoneCode) => ({
        label: `${phoneCode.code} (${phoneCode.country})`,
        value: phoneCode,
      }))
    }
  },
  methods: {
    validPhoneNumberRule(phoneNumber)
    {
      return validPhoneNumber(this.phoneCode.value.code + phoneNumber);
    },
    // Rule to ensure that the user doesn't try and add a phone number twice
    duplicatePhoneNumberRule(phoneNumber)
    {
      return (
        this.participants[
        parseNumber(this.phoneCode.value.code + phoneNumber).number
        ] == undefined || this.$t("invite_arbitrary_number.no_duplicates")
      );
    },
    handleAddPerson()
    {
      this.inviteParticipant(
        parseNumber(this.phoneCode.value.code + this.number).number,
        {
          Name: this.Name,
          Moderator: this.Moderator,
        },
        this.AddContact
      );
      this.$refs.formRef.reset();
    },
    handleResetForm()
    {
      this.Moderator = false;
      this.number = null;
      this.Name = null;
    },
  },
};
</script>
